<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla controller library
jimport('joomla.application.component.controller');

class mjformsControllerImportjforms extends JController {

    function display() {
        JRequest::setVar('view', 'importjforms');
        parent::display();
    }
    
    function import() {
        JRequest::checkToken() or jexit('Invalid Token');
        
        $check_file = 1;
        $model = $this->getModel('importjforms');
        $post = JRequest::get('post');
        $path_file = '';
        $ext = JFile::getExt($_FILES['file_import']['name']);
        if($post['type_import'] == 'package' && $ext != 'zip') {
            $check_file = 0;
            JError::raiseWarning('', JText::_('MJFORM_IMPORT_ERROR_TYPE_FILE'));
        } else {
            $path_file = $_FILES['file_import']['tmp_name'];
        }
        
        if($post['type_import'] == 'dir') {
            $dir = $post['file_dir'];
            $ext = explode('.', $dir);
            if(count($ext) == 2) {
                $path_file = $dir;
            } else {
                $files = JFolder::files($dir);
                foreach ($files as $file) {
                    $ext = explode('.', $file);
                    if($ext[1] == 'zip') {
                        $path_file = $post['file_dir'].$file;
                        break;
                    }
                }
            }
            
            if($path_file == '') {
                $check_file = 0;
                JError::raiseWarning('', JText::_('MJFORM_IMPORT_ERROR_SELECT_URL'));
            }
        }
        
        if($post['type_import'] == 'url') {
            $dir = $post['file_url'];
            $ext = explode('.', $dir);
            if(count($ext) == 2) {
                $path_file = $dir;
            } else {
                $check_file = 0;
                JError::raiseWarning('', JText::_('MJFORM_IMPORT_ERROR_SELECT_URL'));
            }
        }
        
        if($check_file == 1) {
            $return = $model->importForms($path_file);
            if($return) {
                $this->setRedirect('index.php?option=com_mjforms&controller=importjforms', JText::_('MJFORM_IMPORT_SUCCESS'));
            } else {
                JError::raiseWarning('', JText::_('MJFORM_IMPORT_DUPLICATE'));
            }
        }
        
        $this->display();
    }
    
    function deleteform() {
        $id = JRequest::getVar('id');
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->delete($db->nameQuote('#__mjforms_forms'))->where($db->nameQuote('id').'='.$db->quote($id));
        $db->setQuery($query);
        $db->query();
        
        $query->clear();
        $query->delete($db->nameQuote('#__mjforms_fields'))->where($db->nameQuote('pid').'='.$db->quote($id));
        $db->setQuery($query);
        $db->query();
        
        $query->clear();
        $query->delete($db->nameQuote('#__mjforms_parameters'))->where($db->nameQuote('fid').'='.$db->quote($id));
        $db->setQuery($query);
        $db->query();
        
        $query->clear();
        $query->delete($db->nameQuote('#__mjforms_tparameters'))->where($db->nameQuote('fid').'='.$db->quote($id));
        $db->setQuery($query);
        $db->query();
        echo 'ok'; jexit();
    }

}