<?php
/**
* A Form element that lists user groups, allows user to select what groups can use the form
* 
* @version		$Id: mjformsusergroup.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Elements
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

require JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter'.DS.'element.php';
/**
 * A Form element that lists user groups, allows user to select what groups can use the form
 *
 * @package    Joomla
 * @subpackage mjforms.Elements
 */
class jelementmjformsusergroup extends JElement
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'mjformsUserGroup';
	
	/**
	* Generates the HTML for the element
	*
	* @access	public
	* @param string index of the element in the HTML array
	* @param string default value for the element
	* @param object the XML parameters object
	* @param string HTML array name
	* @return string HTML for the element
	*/
	function fetchElement($name, $value, &$node, $control_name)
	{
 
    //$return = '3333333<input type="text" value="555555555"  />44444'; 
    //return $return;            
            
            
		/*
		$acl =& JFactory::getACL();

		$guestACL = new stdClass();
		$guestACL->value	= 0;
		$guestACL->text		= JText::_('Guest');
		$guestACL->disable	= false;

		$gtree  = array($guestACL);
		print_r( $acl->get_group_children_tree( null, 'USERS', false ) );
                 */
                $db = JFactory::getDbo();
                $query	= $db->getQuery(true);

		// Select the required fields from the table.
		$query->select('a.*');
		$query->from($db->quoteName('#__usergroups').' AS a');

		// Add the level in the tree.
		$query->select('COUNT(DISTINCT c2.id) AS level');
		$query->join('LEFT OUTER', $db->quoteName('#__usergroups').' AS c2 ON a.lft > c2.lft AND a.rgt < c2.rgt');
		$query->group('a.id, a.lft, a.rgt, a.parent_id, a.title');
                $db->setQuery($query);
                $db->query();
                
                $rows = $db->loadAssocList();
                $arr_selected = explode(',', $value);
                $selected = '';
                for($i = 0, $loop = count($rows); $i < $loop; $i++) {
                    $key = $rows[$i]['id'];
                    if(in_array($key, $arr_selected)) {
                        $selected[] = $key;
                    }
                    $usergroups[$key] = str_repeat(' - ', $rows[$i]['level']).$rows[$i]['title'];
                }

                foreach($usergroups as $key=>$value) {
                    $options[] = JHTML::_('select.option', $key, $value);
                }
                $selected = $selected == '' ? $options : $selected;
                return JHTML::_('select.genericlist', $options, 'params[groups][]', 'class="inputbox" style="width:150px;height:90px;" multiple="multiple"','value', 'text', $selected);
                
		//$gtree = array_merge($gtree, $acl->get_group_children_tree( null, 'USERS', false ));
                
//		$ctrl	= $control_name .'['. $name .']';
//
//	
//		$attribs	= ' ';
//		$v = $node->attributes('size');
//		if ($v) {
//			$attribs	.= 'size="'.$v.'"';
//		}
//		$v = $node->attributes('class');
//		if ($v) {
//			$attribs	.= 'class="'.$v.'"';
//		} else {
//			$attribs	.= 'class="inputbox"';
//		}
//		$attribs	.= 'multiple="multiple"';
//		$ctrl		.= '[]';
//return JHTML::_('select.genericlist',   $gtree, $ctrl, $attribs, 'value', 'text', explode(',',$value), $control_name.$name );
	}
}
