<?php
/**
* Design View
*
* @version		$Id: view.html.php 373 2010-03-27 12:34:45Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Views
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.view');
require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'general.php';
require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'elements'.DS.'mjformsusergroup.php';
//$v = new jelementmjformsusergroup;

/**
 * Design View
 *
 * @package    Joomla
 * @subpackage mjforms.Views
 */
class mjformsviewdesign extends JView
{
	/**
	 * Design view display method
	 *
	 * The WYSIWYG form design environment , Where all the magic is going to happen 
	 *
	 * @return void
	 **/
	function display( $form=null )
	{	
		//Disable top menu "Thanks Ercan :)"
		JRequest::setVar('hidemainmenu', 1);		

                // ของเก่า
		//Loads latest mootools version
		//JHTML::_('mjforms.General.mootools');
		//JHTML::_('mjforms.General.IE');
                
                                    mjformsgeneral::mootools();
                                    mjformsgeneral::IE();
		
                                    // ของเก่า
		//JHTML::_('stylesheet', 'design-backend.css'  , 'media/com_mjforms/styles/');
		//JHTML::_('stylesheet', 'design-form.css'     , 'media/com_mjforms/styles/');
                                    
                                    $document =& JFactory::getDocument();        
                                    $css1 = JURI::root().'media/com_mjforms/styles/design-backend.css';
                                    $css2 = JURI::root().'media/com_mjforms/styles/design-form.css';
                                    $document->addStyleSheet( $css1, 'text/css', 'all');
                                    $document->addStyleSheet( $css2, 'text/css', 'all');
                                    
		//Toolbar
		JToolBarHelper::title(   JText::_( 'Design' ), 'mjforms-design' );
		JToolBarHelper::save();
		JToolBarHelper::cancel();
		
		//$this->assignRef('form' ,$form); 
                        //$this->form = $form; เปลี่ยนเป็นรับค่า $this->form ในหน้า default ได้เลย
                    //Display the template
		parent::display();
		
	}
}