<?php
/**
* Default layout for list view
*
* @version		$Id: default.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Layouts
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/
defined('_JEXEC') or die('Restricted access');
JHTML::_('behavior.tooltip');

$function	= JRequest::getCmd('function', 'jSelectMjforms');
if (JFactory::getApplication()->isSite()) {
	JSession::checkToken('get') or die(JText::_('JINVALID_TOKEN'));
}
?>

<form action="index.php" method="get" name="adminForm" id='adminForm'>
<div id="editcell">
	<table class="adminlist">
	<thead>
		<tr>
			<th width="5">
				<?php echo JText::_( 'Id' ); ?>
			</th>			
			<th width="40%">
				<?php echo JText::_( 'Title' ); ?>
			</th>
			<th>
				<?php echo JText::_( 'Table name' ); ?>
			</th>
			<th width="100">
				<?php echo JText::_( 'Publish Information' ); ?>
			</th>
			<th>
				<?php echo JText::_( 'Author' ); ?>
			</th>
			<th>
				<?php echo JText::_( 'Date' ); ?>
			</th>
			
			
		</tr>			
	</thead>
	<?php
	$k = 0;
	$config	=& JFactory::getConfig();
	$db     =& JFactory::getDBO();
	$now	=& JFactory::getDate();
	$nullDate = $db->getNullDate();
	for ($i=0, $n=count( $this->forms ); $i < $n; $i++){
	
		$row = &$this->forms[$i];
		$checked 	= JHTML::_('grid.checkedout',   $row, $i );
		
		/* Publish icon stuff , faithfully copied "with minor modifications" from com_content */
		$date		= JHTML::_('date',  $row->created, JText::_('DATE_FORMAT_LC4') );
		$publish_up =& JFactory::getDate($row->publish_up);
		$publish_down =& JFactory::getDate($row->publish_down);
		$publish_up->setOffset($config->getValue('config.offset'));
		$publish_down->setOffset($config->getValue('config.offset'));
		if ( $now->toUnix() <= $publish_up->toUnix() && $row->state == 1 ) {
				$img = 'publish_y.png';
				$alt = JText::_( 'Published' );
		} else if ( ( $now->toUnix() <= $publish_down->toUnix() ||
					  $row->publish_down == $nullDate ) && $row->state == 1 ) {
			$img = 'publish_g.png';
			$alt = JText::_( 'Published' );
		} else if ( $now->toUnix() > $publish_down->toUnix() && $row->state == 1 ) {
			$img = 'publish_r.png';
			$alt = JText::_( 'Expired' );
		} else if ( $row->state == 0 ) {
			$img = 'publish_x.png';
			$alt = JText::_( 'Unpublished' );
		}	
		$times = '';
		if (isset($row->publish_up)) {
			if ($row->publish_up == $nullDate) {
				$times .= JText::_( 'Start: Always' );
			} else {
				$times .= JText::_( 'Start' ) .": ". $publish_up->toFormat();
			}
		}
		if (isset($row->publish_down)) {
			if ($row->publish_down == $nullDate) {
				$times .= "<br />". JText::_( 'Finish: No Expiry' );
			} else {
				$times .= "<br />". JText::_( 'Finish' ) .": ". $publish_down->toFormat();
			}
		}
		/* End of publish icon stuff */
		?>
		<tr class="<?php echo "row$k"; ?>">
			<td>
				<?php echo $row->id; ?>
			</td>
			<td>
                                <a class="pointer" onclick="if (window.parent) window.parent.<?php echo $this->escape($function);?>('<?php echo $row->id; ?>');">
				<?php echo $row->title; ?></a>
			</td>
			<td align="center">
				<?php echo $db->getPrefix().'mjforms_'.$row->table_name; ?>
				
			</td>			
			<td align="center">
			<span class="editlinktip hasTip" title="<?php echo JText::_( 'Publish Information' );?>::<?php echo $times; ?>">
                                <?php echo JHtml::_('jgrid.published', $row->state, $i, '', false); // แก้เป็นแบบ 2.5  ?>
			</span>
			</td>
			<td align="center">
				<?php echo $row->author; ?>
			</td>
			<td align="center">
				<?php echo JHTML::_('date',  $row->created, JText::_('DATE_FORMAT_LC4') ); ?>
			</td>
		</tr>
		<?php
		$k = 1 - $k;
	}
	?>
	</table>
</div>

<input type="hidden" name="option" value="com_mjforms" />
<input type="hidden" name="controller" value="forms" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="newName" value="" />
<?php echo JHTML::_( 'form.token' ); ?>	
</form>

<?php 
// ทั้งสองอันใช้ไม่ได้ใน 2.5
//JHTML::_('mjforms.Forms.legend'); 
?>
<div style="clear: both;"></div>
<?php JHTML::_('mjforms.General.version'); ?>
<style>
    #footer {
        display: none;
    }
</style>