<?php
/**
* Records View
*
* @version		$Id: view.html.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Tables
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Records View
 *
 * @package    Joomla
 * @subpackage mjforms.Tables
 */
class mjformsviewrecords extends JView
{

	/**
	 * Records view display method
	 *
	 * Displays Records (Stored data)
	 *
	 * @return void
	 **/
	function display($form = null)
	{
		if( !count($this->form->records)){ // รับค่า พารามิเตอร์ จาก Controller
			echo '<div style="font-size:150%;text-align:center;color:red;font-weight:bold">'.JText::_('No records stored yet').'<br /><br /><a href="javascript:history.back();">&lt;&lt; '.JText::_('Go Back').'</a></div>';
			return;
		}
	
		//JHTML::_('stylesheet', 'reset.css'          , 'media/com_mjforms/styles/general/');
		JHTML::_('stylesheet', 'records-backend.css', 'media/com_mjforms/styles/');
		JHTML::_('stylesheet', 'grid.css'			, 'media/com_mjforms/styles/');

		JRequest::setVar('hidemainmenu', 1);		
		
		JHTML::_('mjforms.General.mootools');

		JToolBarHelper::title(   JText::_( 'Records' ), 'mjforms-records' );
		JToolBarHelper::back(JText::_('Back'), JRoute::_('index.php?option=com_mjforms&controller=forms'));

		$this->assignRef('form', $this->form);
	
		//Display the template
		parent::display();
	}
}