<?php
/**
* mjforms Installation script
*
* @version		$Id: install.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	mjforms.Install
* @copyright	Copyright (C) 2009 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

ignore_user_abort( true );


/**
 * Installs and publishes mjforms content plugin
 * 
 * @access	public
 */
class com_mjformsInstallerScript {
    
    function install($parent) {

	$db = JFactory::getDBO();

	/*					Install plugin 					*/
//	if(!JFile::exists(JPATH_PLUGINS.DS.'content'.DS.'mjforms'.DS.'mjforms.php')){
//                JFolder::create(JPATH_PLUGINS.DS.'content'.DS.'mjforms');
//		JFile::copy(
//				MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'content'.DS.'mjforms'.DS.'mjforms.php',
//				JPATH_PLUGINS.DS.'content'.DS.'mjforms'.DS.'mjforms.php'
//		);
//		JFile::copy(
//				MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'content'.DS.'mjforms'.DS.'mjforms.xml',
//				JPATH_PLUGINS.DS.'content'.DS.'mjforms'.DS.'mjforms.xml'
//		);
//	}
//	JFolder::delete(MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'content');
//        
//        if(!JFile::exists(JPATH_PLUGINS.DS.'editors-xtd'.DS.'mjforms'.DS.'mjforms.php')){
//                JFolder::create(JPATH_PLUGINS.DS.'editors-xtd'.DS.'mjforms');
//		JFile::copy(
//				MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'editors-xtd'.DS.'mjforms'.DS.'mjforms.php',
//				JPATH_PLUGINS.DS.'editors-xtd'.DS.'mjforms'.DS.'mjforms.php'
//		);
//		JFile::copy(
//				MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'editors-xtd'.DS.'mjforms'.DS.'mjforms.xml',
//				JPATH_PLUGINS.DS.'editors-xtd'.DS.'mjforms'.DS.'mjforms.xml'
//		);
//	}
//	JFolder::delete(MJFORMS_PLUGINS_PATH.DS.'plugins'.DS.'editors-xtd');
        
        $plg_installer = new JInstaller();
        $p = $parent->get('parent');
        $plg_installer->install($p->getPath('source').DS.'plugins'.DS.'content');
        $plg_installer->install($p->getPath('source').DS.'plugins'.DS.'editors-xtd');
        
	$query = 'SELECT `enabled` FROM `#__extensions` WHERE `element`="mjforms" AND `folder`="content"';
	$db->setQuery($query);
	$result = $db->loadObject();
	
	if($result == null){
		$query = 
		"INSERT INTO `#__extensions` ( `name`, `type`, `element`, `folder`, `access`, `ordering`, `enabled`, `client_id`, `checked_out`, `checked_out_time`, `params`)"
		."\nVALUES"
		."\n('Content - mjforms','plugin', 'mjforms', 'content', 1, 0, 1, 0, 0, '0000-00-00 00:00:00', '')";
		$db->setQuery($query);
		$db->query();
	} else {
		$query = 'UPDATE `#__extensions` SET `enabled` = 1 WHERE `element`="mjforms" AND `folder`="content"';
		$db->setQuery($query);
		$db->query();
	}
        
        $query = 'SELECT `enabled` FROM `#__extensions` WHERE `element`="mjforms" AND `folder`="editors-xtd"';
	$db->setQuery($query);
	$result = $db->loadObject();
	
	if($result == null){
		$query = 
		"INSERT INTO `#__extensions` ( `name`, `type`, `element`, `folder`, `access`, `ordering`, `enabled`, `client_id`, `checked_out`, `checked_out_time`, `params`)"
		."\nVALUES"
		."\n('Editors-xtd - mjforms','plugin', 'mjforms', 'editors-xtd', 1, 0, 1, 0, 0, '0000-00-00 00:00:00', '')";
		$db->setQuery($query);
		$db->query();
	} else {
		$query = 'UPDATE `#__extensions` SET `enabled` = 1 WHERE `element`="mjforms" AND `folder`="editors-xtd"';
		$db->setQuery($query);
		$db->query();
	}

        $query = 'SELECT element FROM '.$db->nameQuote('#__extensions')
                .' WHERE '.$db->nameQuote('type').'='.$db->quote('language')
                .' AND '.$db->nameQuote('client_id').'='.$db->quote('1');
        $db->setQuery($query);
        $db->query();
        
        $path = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_mjforms'.DS.'installation'.DS;
        $arr_language = $db->loadResultArray();
        $arr_sample = '';
        if(in_array('en-GB', $arr_language)) {
            $arr_sample[] = $path.'sample_forms_en.xml';
        }
        if(in_array('th-TH', $arr_language)) {
            $arr_sample[] = $path.'sample_forms_th.xml';
        }
        $prefix = $db->getPrefix();
        
        foreach ($arr_sample as $file) {
            $data = $this->xmlToArray($file);
            $this->importXML($data);
            
//            $data = str_replace('#__jforms_', $prefix.'mjforms_', $data);
//            $data = str_replace('#__mjforms_', $prefix.'mjforms_', $data);
//            $xml = simplexml_load_string($data, 'SimpleXMLElement');
//            $xml = $xml->children();
//            $tables = array();
//            $rows = array();
//            $tempRow = array();
//            $tempCells = array();
//            $crate_table = array();
//            if (@count($xml->children())) {
//                foreach ($xml as $v0) {
//                    foreach ($v0->mjts->mjt as $k1 => $v1) {
//                        $tbl_attr = $v1->attributes();
//                        $isInTables = false;
//                        if(in_array((string)$tbl_attr['name'], $tables)) {
//                            $isInTables = true;
//                        }
//
//                        if ($isInTables == false) {
//                            $tables[] = array((string)$tbl_attr['name']);
//                        }
//                        if(isset($v1->mjcs->mjc)) {
//                            foreach ($v1->mjcs->mjc as $k2 => $v2) {
//                                $row_attr = $v2->attributes();
//                                if (!array_search((string)$row_attr['name'], $tempRow))
//                                {
//                                    $tempRow[] = (string)$row_attr['name'];
//                                }
//                                $tempCells[] = (string)$v2;
//                            }
//                            $rows[] = array((string)$tbl_attr['name'], $tempRow, $tempCells);
//                            $tempRow = array();
//                            $tempCells = array();
//                        } 
//
//                        if(isset($v1->cmjt)) {
//                            foreach ($v1 as $k2 => $v2) {
//                                $crate_table[] = (string) $v2;
//                            }
//                        }
//                    }
//                }
//                unset($tempRow);
//                unset($tempCells);
//                unset($xml);
//            }
//
//            
//            $param = array('tables' => $rows, 'create_tables' => $crate_table);
//            $user = JFactory::getUser();
//            $create_tables = $param['create_tables'];
//            if(count($create_tables) > 0) {
//                foreach ($create_tables as $query_table) {
//                    $query = str_replace('CREATE TABLE', 'CREATE TABLE IF NOT EXISTS', $query_table);
//                    $db->setQuery($query);
//                    $db->query();
//                }
//            }
//
//            $data = $param['tables'];
//            $name_form = '';
//            $plugin_name = '';
//            $parameter_value = '';
//            foreach ($data as $mjform) {
//                $table_name = $mjform[0];
//                if(!isset($mjform[1])) {
//                    continue;
//                }
//                $table_fields = $mjform[1];
//                $table_values =$mjform[2];
//                if(stripos($table_name, 'mjforms_forms', 0) && $name_form != $table_values[1]) {
//                    $query = 'SELECT id FROM '.$db->nameQuote('#__mjforms_forms')
//                            .' WHERE '.$db->nameQuote('title').'='.$db->quote($table_values[1]);
//                    $db->setQuery($query);
//                    $db->query();
//                    $result = $db->loadResult();
//                    if($result) {
//                        break;
//                    }
//                    $name_form = $table_values[1];
//                    $fid = 0;
//                    $pid = array();
//                    $pp = -1;
//                    $tp = -1;
//                }
//
//                $query = 'INSERT INTO '.$db->nameQuote($table_name).' (';
//                foreach ($table_fields as $field) {
//                    $query .= $db->nameQuote($field).',';
//                }
//                $query = substr($query, 0, strlen($query) - 1);
//                $query .= ') VALUES (';
//                if(stripos($table_name, 'mjforms_parameters',0) || stripos($table_name, 'mjforms_tparameters',0)) {
//                    if($table_values[3] == 'Database' || $table_values[3] == 'Mail') {
//                        $table_values[2] = '0';
//                    } else {
//                        if(($table_values[5] == 'hash' && stripos($table_name, 'mjforms_parameters',0)) || (stripos($table_name, 'mjforms_tparameters',0) && $table_values[5] == 'label')) {
//                            if(stripos($table_name, 'mjforms_parameters',0)) {
//                                $pp++;
//                            } else {
//                                $tp++;
//                            }
//                            $plugin_name = $table_values[3];
//                            $parameter_value = $table_values[6];
//                        }
//                    }
//                }
//                foreach ($table_values as $values) {
//                    if($values == '{admin}') {
//                        $values = $user->id;
//                    }
//                    if($values == '{fid}') {
//                        $values = $fid;
//                    }
//                    if($values == '{pid}' && stripos($table_name, 'mjforms_tparameters',0)) {
//                        if(isset($pid[$tp])) {
//                            $values = $pid[$tp];
//                        }
//                    } else if($values == '{pid}' && stripos($table_name, 'mjforms_parameters',0)) {
//                        if(isset($pid[$pp])) {
//                            $values = $pid[$pp];
//                        }
//                    }
//                    $query .= $db->quote($values).',';
//
//                }
//                $query = substr($query, 0, strlen($query) - 1);
//                $query .= ')';
//                $db->setQuery($query);
//                $db->query();
//                if(stripos($table_name, 'mjforms_forms', 0)) {
//                    $fid = $db->insertid();
//                } else if(stripos($table_name, 'mjforms_fields',0)) {
//                    $pid[] = $db->insertid();
//                }
//            }
        }
        
        $arr_path[] = JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'files'.DS.'7b0ce';
        $arr_path[] = JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'files'.DS.'8942c';
        $arr_path[] = JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'files'.DS.'7b0ce'.DS.'hd74d';
        $arr_path[] = JPATH_ROOT.DS.'media'.DS.'com_mjforms'.DS.'files'.DS.'8942c'.DS.'hd74d';
        
        foreach ($arr_path as $path) {
            if(!JFolder::create($path)) {
                //JLog::add(__LINE__.'Error;;->'.$path);
            }
        }

    }
    
    function xmlToArray($file_path) {
        $content_xml = file_get_contents($file_path);
        $xml = simplexml_load_string($content_xml, 'SimpleXMLElement');
        //$xml = $xml->children()->children()->children();
        $xml = $xml->children();
        $tables = array();
        $rows = array();
        $tempRow = array();
        $tempCells = array();
        $crate_table = array();
        if (@count($xml->children())) {
            foreach ($xml as $v0) {
                foreach ($v0->mjts->mjt as $k1 => $v1) {
                    $tbl_attr = $v1->attributes();
                    $isInTables = false;
                    if(in_array((string)$tbl_attr['name'], $tables)) {
                        $isInTables = true;
                    }

                    if ($isInTables == false) {
                        $tables[] = array((string)$tbl_attr['name']);
                    }
                    if(isset($v1->mjcs->mjc)) {
                        foreach ($v1->mjcs->mjc as $k2 => $v2) {
                            $row_attr = $v2->attributes();
                            if (!array_search((string)$row_attr['name'], $tempRow))
                            {
                                $tempRow[] = (string)$row_attr['name'];
                            }
                            $tempCells[] = (string)$v2;
                        }
                        $rows[] = array((string)$tbl_attr['name'], $tempRow, $tempCells);
                        $tempRow = array();
                        $tempCells = array();
                    } 

                    if(isset($v1->cmjt)) {
                        foreach ($v1 as $k2 => $v2) {
                            $row_attr = $v2->attributes();
                            $key = (string)$row_attr['name'];
                            $crate_table[$key] = (string) $v2;
                        }
                    }
                }
            }
            unset($tempRow);
            unset($tempCells);
            unset($xml);
        }
        return array('tables' => $rows, 'create_tables' => $crate_table);
    }
    
    function importXML($param) {
        $config = JFactory::getConfig();
        $dbname = $config->get('db');
        $prefig = $config->get('dbprefix');
        $user = JFactory::getUser();
        $db = JFactory::getDbo();
        $create_tables = $param['create_tables'];
        if(count($create_tables) > 0) {
            foreach ($create_tables as $table_name => $query_table) {
                $table_name = str_replace('#__', $prefig, $table_name);
                $db->setQuery("SELECT table_name FROM information_schema.tables WHERE table_schema = '$dbname' AND table_name = '$table_name'");
                $db->query();
                $result = $db->loadResult();
                if(!empty($result)) {
                    return false;
                }
                $query = str_replace('CREATE TABLE', 'CREATE TABLE IF NOT EXISTS', $query_table);
                $db->setQuery($query);
                $db->query();
            }
        }

        $data = $param['tables'];
        $name_form = '';
        $plugin_name = '';
        $parameter_value = '';
        foreach ($data as $mjform) {
            $table_name = $mjform[0];
            if(!isset($mjform[1])) {
                continue;
            }
            $table_fields = $mjform[1];
            $table_values =$mjform[2];
            if($table_name == '#__mjforms_forms' && $name_form != $table_values[1]) {
                $name_form = $table_values[1];
                $fid = 0;
                $pid = array();
                $pp = -1;
                $tp = -1;
            }
            
            $query = 'INSERT INTO '.$db->nameQuote($table_name).' (';
            foreach ($table_fields as $field) {
                $query .= $db->nameQuote($field).',';
            }
            $query = substr($query, 0, strlen($query) - 1);
            $query .= ') VALUES (';
            if($table_name == '#__mjforms_parameters' || $table_name == '#__mjforms_tparameters') {
                if($table_values[3] == 'Database' || $table_values[3] == 'Mail') {
                    $table_values[2] = '0';
                } else {
                    if(($table_values[5] == 'hash' && $table_name == '#__mjforms_parameters') || ($table_name == '#__mjforms_tparameters' && $table_values[5] == 'label')) {
                        if($table_name == '#__mjforms_parameters') {
                            $pp++;
                        } else {
                            $tp++;
                        }
                        $plugin_name = $table_values[3];
                        $parameter_value = $table_values[6];
                    }
                }
            }
            foreach ($table_values as $values) {
                if($values == '{admin}') {
                    $values = $user->id;
                }
                if($values == '{fid}') {
                    $values = $fid;
                }
                if($values == '{pid}' && $table_name == '#__mjforms_tparameters') {
                    if(isset($pid[$tp])) {
                        $values = $pid[$tp];
                    }
                } else if($values == '{pid}' && $table_name == '#__mjforms_parameters') {
                    if(isset($pid[$pp])) {
                        $values = $pid[$pp];
                    }
                }
                $query .= $db->quote($values).',';
                
            }
            $query = substr($query, 0, strlen($query) - 1);
            $query .= ')';
            $db->setQuery($query);
            $db->query();
            if($table_name == '#__mjforms_forms') {
                $fid = $db->insertid();
            } else if($table_name == '#__mjforms_fields') {
                $pid[] = $db->insertid();
            }
        }
        return true;
    }

    function uninstall($parent) {
        $db =& JFactory::getDBO();
	/*					uninstall plugin 					*/
	JFolder::delete(JPATH_PLUGINS.DS.'content'.DS.'mjforms');
	JFolder::delete(JPATH_PLUGINS.DS.'editors-xtd'.DS.'mjforms');

	$query = 'DELETE FROM `#__extensions` WHERE `element`="mjforms"';
	$db->setQuery($query);
	$db->query();
	/*					Done uninstalling plugin					*/

	/*					Delete record tables							*/
		
	$sql = 'SELECT `parameter_value` FROM `#__mjforms_parameters` WHERE 
	`parameter_name` = "tableName" AND `plugin_name` ="Database" AND `plugin_type`=0';
	$db->setQuery( $sql );
        $db->query();
        $rows = $db->loadRowList();
        for($i = 0, $loop = count($rows); $i < $loop; $i++) {
            if($i == 0) {
                $table = '#__mjforms_'.$rows[$i][0];
            } else {
                $table .= ', #__mjforms_'.$rows[$i][0];
            }
        }
	
	$sql = "DROP TABLE $table";
	$db->setQuery( $sql );
	$db->query();
    }

    function update($parent) {
                // $parent is the class calling this method
                //echo '<p>' . JText::sprintf('COM_HELLOWORLD_UPDATE_TEXT', $parent->get('manifest')->version) . '</p>';
    }
 
    /**
     * method to run before an install/update/uninstall method
     *
     * @return void
     */
    function preflight($type, $parent) 
    {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            //echo '<p>' . JText::_('COM_HELLOWORLD_PREFLIGHT_' . $type . '_TEXT') . '</p>';
    }

    /**
     * method to run after an install/update/uninstall method
     *
     * @return void
     */
    function postflight($type, $parent) 
    {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            //echo '<p>' . JText::_('COM_HELLOWORLD_POSTFLIGHT_' . $type . '_TEXT') . '</p>';
    }
}