<?php
jimport('joomla.client.helper');
jimport('joomla.error.log');

class Helper {
    
    public $msg = '';
    
    function addSubmenu($vName) {
        
            JSubMenuHelper::addEntry(
                    JText::_('MJFORM_TITLE'),
                    'index.php?option=com_mjforms',
                    $vName == 'cpanel'
            );
        
            JSubMenuHelper::addEntry(
                    JText::_('MJFORM_FORMS'),
                    'index.php?option=com_mjforms&controller=forms',
                    $vName == 'form'
            );
            
            JSubMenuHelper::addEntry(
                    JText::_('MJFORM_EXPORTJFORM'),
                    'index.php?option=com_mjforms&controller=exportjforms',
                    $vName == 'exportjforms'
            );
            
            JSubMenuHelper::addEntry(
                    JText::_('MJFORM_IMPORTJFORM'),
                    'index.php?option=com_mjforms&controller=importjforms',
                    $vName == 'importjforms'
            );
            
            JSubMenuHelper::addEntry(
                    JText::_('MJFORM_INFO'),
                    'index.php?option=com_mjforms&controller=info',
                    $vName == 'info'
            );
       
    }
    
    function getFormRecords($tb) {
        $db = JFactory::getDbo();
        $query = 'SELECT COUNT(id) FROM '.$db->nameQuote('#__mjforms_'.$tb);
        $db->setQuery($query);
        $db->query();
        
        return $db->loadResult();
    }
   
}
?>
