<?php
/**
* IP Address Element plugin
*
* @version		$Id: ip.php 362 2010-02-20 06:50:23Z dr_drsh $
* @package		Joomla
* @subpackage	JForms.Plugins
* @copyright	Copyright (C) 2008 Mostafa Muhammad. All rights reserved.
* @license		GNU/GPL
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
define( 'RAW_IP_EXPORT', 0);

/**
 * IP Address Element plugin 
 *
 * @package    Joomla
 * @subpackage JForms.Plugins
*/
class MJFormEPluginSimple_calculator extends MJFormEPlugin {

	function render( $elementData ) { 
            
		$p = JArrayHelper::toObject($elementData->parameters);
		$htmlId = $p->hash.'_'.$elementData->id;
		//$session =JFactory::getSession();
		//$ses_auto	=	$session->get('ses_auto');
                //$session->set('ses_auto', $p->hash);
                //print_r($p->simple_calculator);
                $arr_calculator = explode('=', $p->simple_calculator);
                $doc =& JFactory::getDocument();
                //$doc->addScript(JURI::root().'media/com_mjforms/scripts/mootools.js');
                $js =   "window.addEvent('domready', function() {
                                
                                var tag_input = new String('".$arr_calculator[0]."');
                                var tag_result = '".$p->hash."';
                                var arr_calculator = new Array();
                                    
                                var obj = $$('input').getProperties('name');
                                for(var i=0; i < obj.length; i++) {
                                        Object.each(obj[i], function(value,key) {
                                                if(tag_input.indexOf(value) != -1) {
                                                        arr_calculator.push(value);
                                                }
                                        });
                                }
                                
                                //console.debug(arr_calculator);
                                $$('input').addEvent('keyup', function() {
                                        var new_input = new String(tag_input);
                                        for(var i=0; i < arr_calculator.length; i++) {
                                                var value = $$('input[name=' + arr_calculator[i] + ']').get('value');
                                                var str = new String(arr_calculator[i]);
                                                if(isNaN(value) || value == '') {
                                                        new_input = new_input.replace(new RegExp(str, 'g'), 0);
                                                } else {
                                                        new_input = new_input.replace(new RegExp(str, 'g'), value);
                                                }
                                        }
                                        $$('input[name=' + tag_result + ']').set('value',eval(new_input));
                                        //console.debug(new_input);
                                });
                        });";

                $doc->addScriptDeclaration($js);
                
		$output	=	"";
                if(isset($p->mw)) {
                    $mw = $p->mw + 50;
                } else {
                    $mw = 0;
                }
                
                if($p->column > 1) {
                    $output .= _line("<div style='display: block; margin-left: {$mw}px;'>",2);
                } else {
                    $output .= _line("<div style=\"".$p->cposition."\">",1);
                }
		$output	.=	_line("<label>$p->label</label><input type='text' value='' name='$p->hash' id='$htmlId' />",2);
		$output	.=	_line("</div>",1);
		return $output;
	}

	function renderview( $elementData ){ 
		$p = JArrayHelper::toObject($elementData->parameters);
		$default = property_exists($elementData,'defaultValue' )?$elementData->defaultValue:$p->defaultValue;
		$htmlId = $p->hash.'_'.$elementData->id;
		$output	=	"";
		$output	.=	_line("<div style=\"".$p->cposition."\"> simple_calculator",1);
		$output	.=	_line("<span>".$default."</span>",2);
		$output	.=	_line("</div>",1);
		return $output;
	}

}