<?php
defined('_JEXEC') or die('Restricted access');
$helper = new Helper;
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));
?>
<form action="<?php echo JRoute::_('index.php'); ?>" method="post" name="adminForm" id="adminForm">
    <table class="adminlist">
        <thead>
            <tr>
                <th width="20">
                    <?php echo JText::_('#'); ?>
                </th>
                <th width="1%">
                    <input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
                </th>
                <th width="45%">
                    <?php echo JHtml::_('grid.sort', 'MJFORM_TITLES', 'm.title', $listDirn, $listOrder);?>
                </th>
                <th>
                    <?php echo JHtml::_('grid.sort', 'MJFORM_TABLENAME', 'table_name', $listDirn, $listOrder);?>
                </th>
                <th>
                    <?php echo JHtml::_('grid.sort', 'MJFORM_CREATE_BY', 'created_by', $listDirn, $listOrder);?>
                </th>
                <th width="150">
                    <?php echo JHtml::_('grid.sort', 'MJFORM_CREATE_TIME', 'created', $listDirn, $listOrder);?>
                </th>
                <th width="20">
                    <?php echo JHtml::_('grid.sort', 'MJFORM_ID', 'm.id', $listDirn, $listOrder);?>
                </th>
                <th width="50">
                    <?php echo JText::_('MJFORM_EXPORT_RECORDS'); ?>
                </th>
            </tr>
        </thead>
        
        <tfoot>
            <td colspan="9"><?php echo $this->pagination->getListFooter(); ?></td>
        </tfoot>
        
        <tbody>
            <?php
            $start = JRequest::getVar('limitstart');
            foreach($this->items as $i => $item) {
                $no = $i + $start + 1;
            ?>
            <tr class="row<?php echo $i % 2; ?>">
                <td align="center">
                    <?php echo $no; ?>
                </td>
                <td class="center">
                    <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                </td>
                <td>
                    <?php echo $item->title; ?>
                </td>
                <td align="center">
                    <?php 
                    echo $this->prefix.'mjforms_'.$item->table_name; 
                    ?>
                </td>
                <td align="center">
                    <?php echo $item->created_by; ?>
                </td>
                <td align="center">
                    <?php echo $item->created; ?>
                </td>
                <td align="center">
                    <?php echo $item->id; ?>
                </td>
                <td align="center">
                    <?php echo $helper->getFormRecords($item->table_name);?>
                </td>
            </tr>
            <?php } ?>
        </tbody>
    </table>
    <div>
        <input type="hidden" name="option" id="option" value="com_mjforms" />
        <input type="hidden" name="controller" id="controller" value="exportjforms" />
        <input type="hidden" name="task" id="task" value="views" />
        <input type="hidden" name="boxchecked" value="0" />
        <input type="hidden" name="filter_order" value="" />
        <input type="hidden" name="filter_order_Dir" value="" />
        <?php echo JHtml::_('form.token'); ?>
    </div>
</form>
<div style="clear: both;"></div>
<?php JHTML::_('mjforms.General.version'); ?>
<style>
    #footer {
        display: none;
    }
</style>